package com.caimei365.user.controller;

import com.caimei365.user.model.JsonModel;
import com.caimei365.user.service.UserService;
import lombok.RequiredArgsConstructor;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Map;

/**
 * 用户公共API
 *
 * @author : Charles
 * @date : 2021/3/4
 */
@RestController
@RequiredArgsConstructor
@RequestMapping("/user")
public class BaseUserApi {

    private final UserService userService;

    /**
     * 获取图片验证码
     * spi旧接口：/user/getImgVerifyCode
     * @param platformType 0:www，1:crm/h5，2:小程序
     */
    @GetMapping("/captcha")
    public JsonModel<Map<String, Object>> getCaptchaImage(Integer platformType) {
        return userService.getCaptchaImage(platformType);
    }

    /**
     * 获取短信验证码
     * spi旧接口：/user/activateCodeByReg
     * @param mobile           手机号
     * @param activateCodeType 1:找回密码,2:手机号注册机构,3:供应商注册
     * @param imgCode          图片验证码
     * @param token            图片验证码token
     * @param platformType     0:www，1:crm/h5，2:小程序
     */
    @GetMapping("/sms/code")
    public JsonModel getSmsCode(String mobile, String activateCodeType, String imgCode, String token, Integer platformType) {
        return userService.getSmsCode(mobile, activateCodeType, imgCode, token, platformType);
    }

    //club
    /**
     * 微信授权登录
     *
     * @param code          微信授权code
     * @param encryptedData 微信加密数据
     * @param iv            加密算法的初始向量
     */
    @PostMapping("/authorization")
    public JsonModel authorizationLogin(String code, String encryptedData, String iv, HttpServletRequest request) {
        return null;
    }

    /**
     * 邀请码授权登录
     */
    @PostMapping("/invitationCode")
    public JsonModel invitationCode(OperationVo operation, HttpServletRequest request) {
        return null;
    }

}
